﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.Charting;
using Telerik.WinControls.UI;

namespace ChartDragDrop
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.radChartView1.ShowLegend = true;

            BarSeries bar = new BarSeries();
            bar.Name = "FakeSeries";
            bar.CombineMode = ChartSeriesCombineMode.Stack;
           
            CategoricalDataPoint point = new CategoricalDataPoint();
            point.Category = "Mc1";
            point.Value = 0;
          
            bar.DataPoints.Add(point);
            point = new CategoricalDataPoint();
            point.Category = "Mc2";
            point.Value = 0;
            bar.DataPoints.Add(point);
            point = new CategoricalDataPoint();
            point.Category = "Mc3";
            point.Value = 0;
            bar.DataPoints.Add(point);
            point = new CategoricalDataPoint();
            point.Category = "Mc4";
            point.Value = 0;
            bar.DataPoints.Add(point);
            point = new CategoricalDataPoint();
            point.Category = "Mc5";
            point.Value = 0;
            bar.DataPoints.Add(point);

            this.radChartView1.Series.Add(bar);
            bar.IsVisibleInLegend = false;
            
            bar = new BarSeries();
            bar.Name = "Series1";
            bar.CombineMode = ChartSeriesCombineMode.Stack;

            point = new CategoricalDataPoint();
            point.Category = "Mc1";
            
            point.Value = 100;
            bar.DataPoints.Add(point);
            point = new CategoricalDataPoint();
            point.Category = "Mc2";
            point.Value = 200;
            bar.DataPoints.Add(point);
            point = new CategoricalDataPoint();
            point.Category = "Mc3";
            point.Value = 1000;
            bar.DataPoints.Add(point);
            point = new CategoricalDataPoint();
            point.Category = "Mc4";
            point.Value = 400;
            bar.DataPoints.Add(point);

            this.radChartView1.Series.Add(bar);

            bar = new BarSeries();
            bar.Name = "Series2";
            bar.CombineMode = ChartSeriesCombineMode.Stack;

            point = new CategoricalDataPoint();
            point.Category = "Mc2";
            point.Value = 1200;
            bar.DataPoints.Add(point);
            point = new CategoricalDataPoint();
            point.Category = "Mc3";
            point.Value = 300;
            bar.DataPoints.Add(point);
            point = new CategoricalDataPoint();
            point.Category = "Mc4";
            point.Value = 600;
            bar.DataPoints.Add(point);
            point = new CategoricalDataPoint();
            point.Category = "Mc5";
            point.Value = 120;
            bar.DataPoints.Add(point);

            this.radChartView1.Series.Add(bar);

            bar = new BarSeries();
            bar.Name = "Series3";
            bar.CombineMode = ChartSeriesCombineMode.Stack;

            point = new CategoricalDataPoint();
            point.Category = "Mc1";
            point.Value = 200;
            bar.DataPoints.Add(point);
            point = new CategoricalDataPoint();
            point.Category = "Mc3";
            point.Value = 100;
            bar.DataPoints.Add(point);
            point = new CategoricalDataPoint();
            point.Category = "Mc4";
            point.Value = 700;
            bar.DataPoints.Add(point);
            point = new CategoricalDataPoint();
            point.Category = "Mc5";
            point.Value = 430;
            bar.DataPoints.Add(point);

            this.radChartView1.Series.Add(bar);         

            this.radChartView1.AllowDrop = true;
            this.radChartView1.MouseDown += radChartView1_MouseDown;
            this.radChartView1.DragDrop += radChartView1_DragDrop;
            this.radChartView1.DragOver += radChartView1_DragOver;

            foreach (var item in this.radChartView1.Series)
            {
                item.ShowLabels = true;
            }

            this.radChartView1.LabelFormatting += radChartView1_LabelFormatting;
        }

        void radChartView1_LabelFormatting(object sender, ChartViewLabelFormattingEventArgs e)
        {
            ((DataPointElement)e.LabelElement.Parent).BorderColor = Color.Red;       
            e.LabelElement.BorderColor = Color.Transparent;
            e.LabelElement.Text = String.Empty;
        }

        void radChartView1_DragOver(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(CategoricalDataPoint)))
            {
                e.Effect = DragDropEffects.Move;
            }
        }

        void radChartView1_DragDrop(object sender, DragEventArgs e)
        {
            CategoricalDataPoint point = e.Data.GetData(typeof(CategoricalDataPoint)) as CategoricalDataPoint;

            if (point != null)
            {
                CategoricalDataPoint dropPoint = null;
                Point dropLocation = this.radChartView1.PointToClient(new Point(e.X, e.Y));

                dropPoint = this.radChartView1.Series[0].HitTest(dropLocation.X, dropLocation.Y) as CategoricalDataPoint;
                                                
                if (dropPoint == null)
                {
                    for (int i = 0; i < this.radChartView1.Bounds.Bottom; i++)
                    {
                        dropPoint = this.radChartView1.Series[0].HitTest(dropLocation.X, i) as CategoricalDataPoint;

                        if (dropPoint != null)
                        {
                            break;
                        }
                    }
                }

                if (dropPoint != null)
                {
                    BarSeries barSeries = point.Parent.Presenter as BarSeries;

                    CategoricalDataPoint clone = new CategoricalDataPoint();
                    clone.Category = dropPoint.Category;
                    clone.Value = point.Value;
                    barSeries.DataPoints.Add(clone);
                    barSeries.DataPoints.Remove(point);
                }
            }
        }

        private void radChartView1_MouseDown(object sender, MouseEventArgs e)
        {
            CategoricalDataPoint point = ((BarSeries)this.radChartView1.Series[0]).HitTest(e.X, e.Y) as CategoricalDataPoint;

            if (point != null)
            {
                this.radChartView1.DoDragDrop(point, DragDropEffects.Move);
            }
        }
    }
}